<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: src/standard/containers/tiglContainersPregelVertex.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_5c4eeb3f12cf4bfba980364a449079c1.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglContainersPregelVertex.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglContainersPregelVertex_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef TIGLPREGELVERTEX_HPP_</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define TIGLPREGELVERTEX_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersVertex_8hpp.html">tiglContainersVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunicationMessage_8hpp.html">tiglCommunicationMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;cmem_allocator.hpp&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersPregelAggregate_8hpp.html">tiglContainersPregelAggregate.hpp</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;tiglPregelMacros.h&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                <span class="keyword">typename</span> IdType = uint32, <span class="keyword">typename</span> MessageType = <a class="code" href="classMessage.html">DblMessage</a>&gt;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classVertexP.html">   35</a></span>&#160;<span class="keyword">class </span><a class="code" href="classVertexP.html">VertexP</a>:</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">public</span> <a class="code" href="classvertex.html">vertex</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;{</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">typedef</span> MessageType                     MESSAGE_TYPE;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">typedef</span> vector&lt;MESSAGE_TYPE&gt;            MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">typedef</span> InitType                        INIT_TYPE;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">typedef</span> <a class="code" href="classAggInfo.html">TIGLContainersAggregate&lt;AlgDataType&gt;</a>            <a class="code" href="classAggInfo.html">AGGREGATE_TYPE</a>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#ifdef CMEM_ENABLE</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">typedef</span> vector&lt;MESSAGE_TYPE, TIGLMemCmemAllocator&lt;MESSAGE_TYPE&gt; &gt;       LOCAL_MESSAGE_BUF;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">typedef</span> vector&lt;MESSAGE_TYPE, allocator&lt;MESSAGE_TYPE&gt; &gt;       LOCAL_MESSAGE_BUF;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classVertexP.html#a42d96a975fbffe4000fb8cd46b5aa44b">   51</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classVertexP.html#a42d96a975fbffe4000fb8cd46b5aa44b">flagActive</a>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">bool</span> flagListedActive;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="classVertexP.html#aa62d1bdeb2a5b1821ff14d7ac2104010">   58</a></span>&#160;    <span class="keyword">static</span> <a class="code" href="classAggInfo.html">AGGREGATE_TYPE</a>   * <a class="code" href="classVertexP.html#aa62d1bdeb2a5b1821ff14d7ac2104010">aggregateInfoPtr</a>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classVertexP.html#ae1b0537605558932e0d0b37c943a5dd8">   61</a></span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classVertexP.html#ae1b0537605558932e0d0b37c943a5dd8">activeWithNoMessage</a>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classVertexP.html#a4396136748432ddfd81318044b419010">   64</a></span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classVertexP.html#a4396136748432ddfd81318044b419010">reactivateFlag</a>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="classVertexP.html#a073ad0f9e1d21754499bde31ad5b4e8f">   73</a></span>&#160;<span class="comment"></span>    <a class="code" href="classVertexP.html#a073ad0f9e1d21754499bde31ad5b4e8f">VertexP</a>(IdType key, <span class="keywordtype">bool</span> noMessageFlag = <span class="keyword">false</span>, <span class="keywordtype">bool</span> inFlagReactivate = <span class="keyword">true</span>):</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <a class="code" href="classvertex.html">vertex</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt; (key) {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="comment">//disableListedActive();</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        activeWithNoMessage = noMessageFlag;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        reactivateFlag = inFlagReactivate;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    }</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    ~<a class="code" href="classVertexP.html">VertexP</a>(){}</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classVertexP.html#ab7bc73775db8b49faad7f1f1941febda">   87</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classVertexP.html#ab7bc73775db8b49faad7f1f1941febda">vote_to_halt</a>()</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    {</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        flagActive = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    }</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="classVertexP.html#a54c31bf57dbd684e6f42fbf66283a87e">   93</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classVertexP.html#a54c31bf57dbd684e6f42fbf66283a87e">isActive</a>()</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    {</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="keywordflow">return</span> flagActive;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    }</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classVertexP.html#aa581f96dfa435abd1af0c0736e3c6d4a">   99</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classVertexP.html#aa581f96dfa435abd1af0c0736e3c6d4a">isActiveWithNoMessage</a>()</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    {</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <span class="keywordflow">return</span> activeWithNoMessage;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    }</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="classVertexP.html#a37ff8508671d66188fff4e91f9547dcd">  106</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classVertexP.html#a37ff8508671d66188fff4e91f9547dcd">canReactivate</a>()</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    {</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="keywordflow">return</span> reactivateFlag;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    }</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> isListedActive()</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <span class="keywordflow">return</span> flagListedActive;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    }</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> listActive()</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    {</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        flagListedActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    }</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> disableListedActive()</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    {</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        flagListedActive = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    }</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="classVertexP.html#a814726329f65bb0db086b41e521e0d80">  133</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classVertexP.html#a814726329f65bb0db086b41e521e0d80">activate</a>()</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    }</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="classVertexP.html#aa7ed5eb0c1d2c351bdc086d42a2684c7">  143</a></span>&#160;<span class="comment"></span>    <span class="keyword">virtual</span> uint32 <a class="code" href="classVertexP.html#aa7ed5eb0c1d2c351bdc086d42a2684c7">compute</a>(MESSAGE_BUF_TYPE * pIn, LOCAL_MESSAGE_BUF * pOut, uint32 numMessages)</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    {</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    }</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="comment">//==================================================================================================================</span></div>
<div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="classVertexP.html#ad9caab616ae90c7f0c6af36953f3f441">  153</a></span>&#160;<span class="comment"></span>    <span class="keyword">virtual</span> uint32 <a class="code" href="classVertexP.html#ad9caab616ae90c7f0c6af36953f3f441">init</a>(INIT_TYPE * initParams, LOCAL_MESSAGE_BUF * pOut)</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    }</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    uint32  getMessageBufSize()</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    {</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">return</span> (this-&gt;outEdges).capacity()*<span class="keyword">sizeof</span>(MESSAGE_TYPE);</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    }</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> setAggPtr(AGGREGATE_TYPE    * infoPtr)</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <a class="code" href="classVertexP.html">VertexP&lt;DataType, AlgDataType, EdgeType, InitType, IdType, MessageType&gt;::aggregateInfoPtr</a> = infoPtr;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="comment">//aggregateInfoPtr = infoPtr;</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    }</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;};</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType = u<span class="keywordtype">int</span>32&gt;</div>
<div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="classBiVertexP.html">  178</a></span>&#160;<span class="keyword">class </span><a class="code" href="classBiVertexP.html">BiVertexP</a>:</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keyword">public</span> <a class="code" href="classbi__vertex.html">bi_vertex</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;{</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="keywordtype">bool</span> flagActive;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00186"></a><span class="lineno"><a class="line" href="classBiVertexP.html#ab7c735ab80f96eb707fc59d1719c1bfc">  186</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classBiVertexP.html#ab7c735ab80f96eb707fc59d1719c1bfc">vote_to_halt</a>()</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    {</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        flagActive = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    }</div>
<div class="line"><a name="l00191"></a><span class="lineno"><a class="line" href="classBiVertexP.html#abaeb1f71e61bd879f8200113f2f30fca">  191</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classBiVertexP.html#abaeb1f71e61bd879f8200113f2f30fca">isActive</a>()</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    {</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="keywordflow">return</span> flagActive;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    }</div>
<div class="line"><a name="l00196"></a><span class="lineno"><a class="line" href="classBiVertexP.html#a928855eb293acb0a202d677a809b1b95">  196</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classBiVertexP.html#a928855eb293acb0a202d677a809b1b95">activate</a>()</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    {</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    }</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;};</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="comment">// defining the static members</span></div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, </div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="keyword">typename</span> IdType, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<a class="code" href="classAggInfo.html">TIGLContainersAggregate&lt;AlgDataType&gt;</a>* <a class="code" href="classVertexP.html">VertexP &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;</a> ::aggregateInfoPtr;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, </div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="keyword">typename</span> IdType, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classVertexP.html">VertexP &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;::activeWithNoMessage</a>;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, </div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="keyword">typename</span> IdType, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classVertexP.html">VertexP &lt;DataType, AlgDataType, EdgeType, InitType, IdType , MessageType&gt;::reactivateFlag</a>;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELVERTEX_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classBiVertexP_html"><div class="ttname"><a href="classBiVertexP.html">BiVertexP</a></div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:178</div></div>
<div class="ttc" id="classVertexP_html_aa581f96dfa435abd1af0c0736e3c6d4a"><div class="ttname"><a href="classVertexP.html#aa581f96dfa435abd1af0c0736e3c6d4a">VertexP::isActiveWithNoMessage</a></div><div class="ttdeci">bool isActiveWithNoMessage()</div><div class="ttdoc">check if the vertex stays active even without messages </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:99</div></div>
<div class="ttc" id="classVertexP_html_ad9caab616ae90c7f0c6af36953f3f441"><div class="ttname"><a href="classVertexP.html#ad9caab616ae90c7f0c6af36953f3f441">VertexP::init</a></div><div class="ttdeci">virtual uint32 init(INIT_TYPE *initParams, LOCAL_MESSAGE_BUF *pOut)</div><div class="ttdoc">virtual core init function. Here it is an empty function that must be overridden by customized vertex...</div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:153</div></div>
<div class="ttc" id="tiglCommunicationMessage_8hpp_html"><div class="ttname"><a href="tiglCommunicationMessage_8hpp.html">tiglCommunicationMessage.hpp</a></div><div class="ttdoc">contains core Massage container class for Pregel </div></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdoc">core data message class definition It handles all the data message fields and processing It is a temp...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationMessage.hpp:29</div></div>
<div class="ttc" id="tiglContainersPregelAggregate_8hpp_html"><div class="ttname"><a href="tiglContainersPregelAggregate_8hpp.html">tiglContainersPregelAggregate.hpp</a></div></div>
<div class="ttc" id="classBiVertexP_html_a928855eb293acb0a202d677a809b1b95"><div class="ttname"><a href="classBiVertexP.html#a928855eb293acb0a202d677a809b1b95">BiVertexP::activate</a></div><div class="ttdeci">void activate()</div><div class="ttdoc">activating the node </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:196</div></div>
<div class="ttc" id="classbi__vertex_html"><div class="ttname"><a href="classbi__vertex.html">bi_vertex</a></div><div class="ttdoc">A vertex class with both input and output edges lists it inherits all the properties of regular verte...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:220</div></div>
<div class="ttc" id="classVertexP_html_a814726329f65bb0db086b41e521e0d80"><div class="ttname"><a href="classVertexP.html#a814726329f65bb0db086b41e521e0d80">VertexP::activate</a></div><div class="ttdeci">void activate()</div><div class="ttdoc">activating the node </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:133</div></div>
<div class="ttc" id="classVertexP_html_a42d96a975fbffe4000fb8cd46b5aa44b"><div class="ttname"><a href="classVertexP.html#a42d96a975fbffe4000fb8cd46b5aa44b">VertexP::flagActive</a></div><div class="ttdeci">bool flagActive</div><div class="ttdoc">active flag </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:51</div></div>
<div class="ttc" id="classBiVertexP_html_ab7c735ab80f96eb707fc59d1719c1bfc"><div class="ttname"><a href="classBiVertexP.html#ab7c735ab80f96eb707fc59d1719c1bfc">BiVertexP::vote_to_halt</a></div><div class="ttdeci">void vote_to_halt()</div><div class="ttdoc">disable the node </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:186</div></div>
<div class="ttc" id="classVertexP_html_a37ff8508671d66188fff4e91f9547dcd"><div class="ttname"><a href="classVertexP.html#a37ff8508671d66188fff4e91f9547dcd">VertexP::canReactivate</a></div><div class="ttdeci">bool canReactivate()</div><div class="ttdoc">check if the vertex can be reactivated by new messages </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:106</div></div>
<div class="ttc" id="classvertex_html"><div class="ttname"><a href="classvertex.html">vertex</a></div><div class="ttdoc">core vertex class that contains all the vertex data and defines all vertex mutations It is a template...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:42</div></div>
<div class="ttc" id="tiglContainersVertex_8hpp_html"><div class="ttname"><a href="tiglContainersVertex_8hpp.html">tiglContainersVertex.hpp</a></div><div class="ttdoc">contains core vertex classes </div></div>
<div class="ttc" id="classVertexP_html_a4396136748432ddfd81318044b419010"><div class="ttname"><a href="classVertexP.html#a4396136748432ddfd81318044b419010">VertexP::reactivateFlag</a></div><div class="ttdeci">static bool reactivateFlag</div><div class="ttdoc">a flag when true the vertex can be reactivated by new messages, otherwise it never wake up once becom...</div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:64</div></div>
<div class="ttc" id="classBiVertexP_html_abaeb1f71e61bd879f8200113f2f30fca"><div class="ttname"><a href="classBiVertexP.html#abaeb1f71e61bd879f8200113f2f30fca">BiVertexP::isActive</a></div><div class="ttdeci">bool isActive()</div><div class="ttdoc">check if the node is active </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:191</div></div>
<div class="ttc" id="classVertexP_html_aa7ed5eb0c1d2c351bdc086d42a2684c7"><div class="ttname"><a href="classVertexP.html#aa7ed5eb0c1d2c351bdc086d42a2684c7">VertexP::compute</a></div><div class="ttdeci">virtual uint32 compute(MESSAGE_BUF_TYPE *pIn, LOCAL_MESSAGE_BUF *pOut, uint32 numMessages)</div><div class="ttdoc">virtual core compute function. Here it is an empty function that must be overridden by customized ver...</div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:143</div></div>
<div class="ttc" id="classVertexP_html_ae1b0537605558932e0d0b37c943a5dd8"><div class="ttname"><a href="classVertexP.html#ae1b0537605558932e0d0b37c943a5dd8">VertexP::activeWithNoMessage</a></div><div class="ttdeci">static bool activeWithNoMessage</div><div class="ttdoc">a flag when true the vertex is processed even with no message, if false it is processed only if there...</div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:61</div></div>
<div class="ttc" id="classVertexP_html_ab7bc73775db8b49faad7f1f1941febda"><div class="ttname"><a href="classVertexP.html#ab7bc73775db8b49faad7f1f1941febda">VertexP::vote_to_halt</a></div><div class="ttdeci">virtual void vote_to_halt()</div><div class="ttdoc">disable the node </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:87</div></div>
<div class="ttc" id="classVertexP_html"><div class="ttname"><a href="classVertexP.html">VertexP</a></div><div class="ttdoc">core vertex class for Pregel Engine (with only output edge buffer). It inherits the core vertex class...</div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:35</div></div>
<div class="ttc" id="classVertexP_html_aa62d1bdeb2a5b1821ff14d7ac2104010"><div class="ttname"><a href="classVertexP.html#aa62d1bdeb2a5b1821ff14d7ac2104010">VertexP::aggregateInfoPtr</a></div><div class="ttdeci">static AGGREGATE_TYPE * aggregateInfoPtr</div><div class="ttdoc">pointer to the aggregate information </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:58</div></div>
<div class="ttc" id="classVertexP_html_a54c31bf57dbd684e6f42fbf66283a87e"><div class="ttname"><a href="classVertexP.html#a54c31bf57dbd684e6f42fbf66283a87e">VertexP::isActive</a></div><div class="ttdeci">bool isActive()</div><div class="ttdoc">check if the node is active </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:93</div></div>
<div class="ttc" id="classAggInfo_html"><div class="ttname"><a href="classAggInfo.html">TIGLContainersAggregate</a></div><div class="ttdoc">base class for aggregate information it holds important aggregate information and methods for updatin...</div><div class="ttdef"><b>Definition:</b> tiglContainersPregelAggregate.hpp:80</div></div>
<div class="ttc" id="classVertexP_html_a073ad0f9e1d21754499bde31ad5b4e8f"><div class="ttname"><a href="classVertexP.html#a073ad0f9e1d21754499bde31ad5b4e8f">VertexP::VertexP</a></div><div class="ttdeci">VertexP(IdType key, bool noMessageFlag=false, bool inFlagReactivate=true)</div><div class="ttdoc">constructor setting parameters and callign the constructor of the base class </div><div class="ttdef"><b>Definition:</b> tiglContainersPregelVertex.hpp:73</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
